diff --git a/src/backend/commands/dbcommands.c b/src/backend/commands/dbcommands.c
index 1901b434c5..7af9401e34 100644
--- a/src/backend/commands/dbcommands.c
+++ b/src/backend/commands/dbcommands.c
@@ -399,7 +399,7 @@ ScanSourceDatabasePgClassTuple(HeapTupleData *tuple, Oid tbid, Oid dbid,
 	Form_pg_class classForm;
 	Oid			relfilenumber = InvalidRelFileNumber;
 
-	classForm = (Form_pg_class) GETSTRUCT(tuple);
+	classForm = GETSTRUCT(pg_class, tuple);
 
 	/*
 	 * Return NULL if this object does not need to be copied.
@@ -579,7 +579,7 @@ CreateDatabaseUsingFileCopy(Oid src_dboid, Oid dst_dboid, Oid src_tsid,
 	scan = table_beginscan_catalog(rel, 0, NULL);
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_tablespace spaceform = (Form_pg_tablespace) GETSTRUCT(tuple);
+		Form_pg_tablespace spaceform = GETSTRUCT(pg_tablespace, tuple);
 		Oid			srctablespace = spaceform->oid;
 		Oid			dsttablespace;
 		char	   *srcpath;
@@ -1792,7 +1792,7 @@ RenameDatabase(const char *oldname, const char *newname)
 	newtup = SearchSysCacheCopy1(DATABASEOID, ObjectIdGetDatum(db_id));
 	if (!HeapTupleIsValid(newtup))
 		elog(ERROR, "cache lookup failed for database %u", db_id);
-	namestrcpy(&(((Form_pg_database) GETSTRUCT(newtup))->datname), newname);
+	namestrcpy(&((GETSTRUCT(pg_database, newtup))->datname), newname);
 	CatalogTupleUpdate(rel, &newtup->t_self, newtup);
 
 	InvokeObjectPostAlterHook(DatabaseRelationId, db_id, 0);
@@ -2284,7 +2284,7 @@ AlterDatabase(ParseState *pstate, AlterDatabaseStmt *stmt, bool isTopLevel)
 				(errcode(ERRCODE_UNDEFINED_DATABASE),
 				 errmsg("database \"%s\" does not exist", stmt->dbname)));
 
-	datform = (Form_pg_database) GETSTRUCT(tuple);
+	datform = GETSTRUCT(pg_database, tuple);
 	dboid = datform->oid;
 
 	if (!pg_database_ownercheck(dboid, GetUserId()))
@@ -2371,7 +2371,7 @@ AlterDatabaseRefreshColl(AlterDatabaseRefreshCollStmt *stmt)
 				(errcode(ERRCODE_UNDEFINED_DATABASE),
 				 errmsg("database \"%s\" does not exist", stmt->dbname)));
 
-	datForm = (Form_pg_database) GETSTRUCT(tuple);
+	datForm = GETSTRUCT(pg_database, tuple);
 	db_id = datForm->oid;
 
 	if (!pg_database_ownercheck(db_id, GetUserId()))
@@ -2481,7 +2481,7 @@ AlterDatabaseOwner(const char *dbname, Oid newOwnerId)
 				(errcode(ERRCODE_UNDEFINED_DATABASE),
 				 errmsg("database \"%s\" does not exist", dbname)));
 
-	datForm = (Form_pg_database) GETSTRUCT(tuple);
+	datForm = GETSTRUCT(pg_database, tuple);
 	db_id = datForm->oid;
 
 	/*
@@ -2581,7 +2581,7 @@ pg_database_collation_actual_version(PG_FUNCTION_ARGS)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("database with OID %u does not exist", dbid)));
 
-	datlocprovider = ((Form_pg_database) GETSTRUCT(tp))->datlocprovider;
+	datlocprovider = (GETSTRUCT(pg_database, tp))->datlocprovider;
 
 	datum = SysCacheGetAttr(DATABASEOID, tp, datlocprovider == COLLPROVIDER_ICU ? Anum_pg_database_daticulocale : Anum_pg_database_datcollate, &isnull);
 	if (isnull)
@@ -2657,7 +2657,7 @@ get_db_info(const char *name, LOCKMODE lockmode,
 			break;
 		}
 
-		dbOid = ((Form_pg_database) GETSTRUCT(tuple))->oid;
+		dbOid = (GETSTRUCT(pg_database, tuple))->oid;
 
 		systable_endscan(scan);
 
@@ -2675,7 +2675,7 @@ get_db_info(const char *name, LOCKMODE lockmode,
 		tuple = SearchSysCache1(DATABASEOID, ObjectIdGetDatum(dbOid));
 		if (HeapTupleIsValid(tuple))
 		{
-			Form_pg_database dbform = (Form_pg_database) GETSTRUCT(tuple);
+			Form_pg_database dbform = GETSTRUCT(pg_database, tuple);
 
 			if (strcmp(name, NameStr(dbform->datname)) == 0)
 			{
@@ -2768,7 +2768,7 @@ have_createdb_privilege(void)
 	utup = SearchSysCache1(AUTHOID, ObjectIdGetDatum(GetUserId()));
 	if (HeapTupleIsValid(utup))
 	{
-		result = ((Form_pg_authid) GETSTRUCT(utup))->rolcreatedb;
+		result = (GETSTRUCT(pg_authid, utup))->rolcreatedb;
 		ReleaseSysCache(utup);
 	}
 	return result;
@@ -2796,7 +2796,7 @@ remove_dbtablespaces(Oid db_id)
 	scan = table_beginscan_catalog(rel, 0, NULL);
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_tablespace spcform = (Form_pg_tablespace) GETSTRUCT(tuple);
+		Form_pg_tablespace spcform = GETSTRUCT(pg_tablespace, tuple);
 		Oid			dsttablespace = spcform->oid;
 		char	   *dstpath;
 		struct stat st;
@@ -2882,7 +2882,7 @@ check_db_file_conflict(Oid db_id)
 	scan = table_beginscan_catalog(rel, 0, NULL);
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_tablespace spcform = (Form_pg_tablespace) GETSTRUCT(tuple);
+		Form_pg_tablespace spcform = GETSTRUCT(pg_tablespace, tuple);
 		Oid			dsttablespace = spcform->oid;
 		char	   *dstpath;
 		struct stat st;
@@ -2968,7 +2968,7 @@ get_database_oid(const char *dbname, bool missing_ok)
 
 	/* We assume that there can be at most one matching tuple */
 	if (HeapTupleIsValid(dbtuple))
-		oid = ((Form_pg_database) GETSTRUCT(dbtuple))->oid;
+		oid = (GETSTRUCT(pg_database, dbtuple))->oid;
 	else
 		oid = InvalidOid;
 
@@ -2999,7 +2999,7 @@ get_database_name(Oid dbid)
 	dbtuple = SearchSysCache1(DATABASEOID, ObjectIdGetDatum(dbid));
 	if (HeapTupleIsValid(dbtuple))
 	{
-		result = pstrdup(NameStr(((Form_pg_database) GETSTRUCT(dbtuple))->datname));
+		result = pstrdup(NameStr((GETSTRUCT(pg_database, dbtuple))->datname));
 		ReleaseSysCache(dbtuple);
 	}
 	else
diff --git a/src/backend/commands/event_trigger.c b/src/backend/commands/event_trigger.c
index f46f86474a..04d5f2ed68 100644
--- a/src/backend/commands/event_trigger.c
+++ b/src/backend/commands/event_trigger.c
@@ -376,7 +376,7 @@ AlterEventTrigger(AlterEventTrigStmt *stmt)
 				 errmsg("event trigger \"%s\" does not exist",
 						stmt->trigname)));
 
-	evtForm = (Form_pg_event_trigger) GETSTRUCT(tup);
+	evtForm = GETSTRUCT(pg_event_trigger, tup);
 	trigoid = evtForm->oid;
 
 	if (!pg_event_trigger_ownercheck(trigoid, GetUserId()))
@@ -419,7 +419,7 @@ AlterEventTriggerOwner(const char *name, Oid newOwnerId)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("event trigger \"%s\" does not exist", name)));
 
-	evtForm = (Form_pg_event_trigger) GETSTRUCT(tup);
+	evtForm = GETSTRUCT(pg_event_trigger, tup);
 	evtOid = evtForm->oid;
 
 	AlterEventTriggerOwner_internal(rel, tup, newOwnerId);
@@ -466,7 +466,7 @@ AlterEventTriggerOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 {
 	Form_pg_event_trigger form;
 
-	form = (Form_pg_event_trigger) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_event_trigger, tup);
 
 	if (form->evtowner == newOwnerId)
 		return;
diff --git a/src/backend/commands/extension.c b/src/backend/commands/extension.c
index 3db859c3ea..fd31544069 100644
--- a/src/backend/commands/extension.c
+++ b/src/backend/commands/extension.c
@@ -159,7 +159,7 @@ get_extension_oid(const char *extname, bool missing_ok)
 
 	/* We assume that there can be at most one matching tuple */
 	if (HeapTupleIsValid(tuple))
-		result = ((Form_pg_extension) GETSTRUCT(tuple))->oid;
+		result = (GETSTRUCT(pg_extension, tuple))->oid;
 	else
 		result = InvalidOid;
 
@@ -204,7 +204,7 @@ get_extension_name(Oid ext_oid)
 
 	/* We assume that there can be at most one matching tuple */
 	if (HeapTupleIsValid(tuple))
-		result = pstrdup(NameStr(((Form_pg_extension) GETSTRUCT(tuple))->extname));
+		result = pstrdup(NameStr((GETSTRUCT(pg_extension, tuple))->extname));
 	else
 		result = NULL;
 
@@ -243,7 +243,7 @@ get_extension_schema(Oid ext_oid)
 
 	/* We assume that there can be at most one matching tuple */
 	if (HeapTupleIsValid(tuple))
-		result = ((Form_pg_extension) GETSTRUCT(tuple))->extnamespace;
+		result = (GETSTRUCT(pg_extension, tuple))->extnamespace;
 	else
 		result = InvalidOid;
 
@@ -2762,7 +2762,7 @@ AlterExtensionNamespace(const char *extensionName, const char *newschema, Oid *o
 
 	/* Copy tuple so we can modify it below */
 	extTup = heap_copytuple(extTup);
-	extForm = (Form_pg_extension) GETSTRUCT(extTup);
+	extForm = GETSTRUCT(pg_extension, extTup);
 
 	systable_endscan(extScan);
 
@@ -2805,7 +2805,7 @@ AlterExtensionNamespace(const char *extensionName, const char *newschema, Oid *o
 
 	while (HeapTupleIsValid(depTup = systable_getnext(depScan)))
 	{
-		Form_pg_depend pg_depend = (Form_pg_depend) GETSTRUCT(depTup);
+		Form_pg_depend pg_depend = GETSTRUCT(pg_depend, depTup);
 		ObjectAddress dep;
 		Oid			dep_oldNspOid;
 
@@ -2927,7 +2927,7 @@ ExecAlterExtensionStmt(ParseState *pstate, AlterExtensionStmt *stmt)
 				 errmsg("extension \"%s\" does not exist",
 						stmt->extname)));
 
-	extensionOid = ((Form_pg_extension) GETSTRUCT(extTup))->oid;
+	extensionOid = (GETSTRUCT(pg_extension, extTup))->oid;
 
 	/*
 	 * Determine the existing version we are updating from
@@ -3079,7 +3079,7 @@ ApplyExtensionUpdates(Oid extensionOid,
 			elog(ERROR, "could not find tuple for extension %u",
 				 extensionOid);
 
-		extForm = (Form_pg_extension) GETSTRUCT(extTup);
+		extForm = GETSTRUCT(pg_extension, extTup);
 
 		/*
 		 * Determine the target schema (set by original install)
diff --git a/src/backend/commands/foreigncmds.c b/src/backend/commands/foreigncmds.c
index ea27857bb8..899e1cceef 100644
--- a/src/backend/commands/foreigncmds.c
+++ b/src/backend/commands/foreigncmds.c
@@ -212,7 +212,7 @@ AlterForeignDataWrapperOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerI
 	Datum		aclDatum;
 	bool		isNull;
 
-	form = (Form_pg_foreign_data_wrapper) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_foreign_data_wrapper, tup);
 
 	/* Must be a superuser to change a FDW owner */
 	if (!superuser())
@@ -290,7 +290,7 @@ AlterForeignDataWrapperOwner(const char *name, Oid newOwnerId)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("foreign-data wrapper \"%s\" does not exist", name)));
 
-	form = (Form_pg_foreign_data_wrapper) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_foreign_data_wrapper, tup);
 	fdwId = form->oid;
 
 	AlterForeignDataWrapperOwner_internal(rel, tup, newOwnerId);
@@ -345,7 +345,7 @@ AlterForeignServerOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 	Datum		aclDatum;
 	bool		isNull;
 
-	form = (Form_pg_foreign_server) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_foreign_server, tup);
 
 	if (form->srvowner != newOwnerId)
 	{
@@ -429,7 +429,7 @@ AlterForeignServerOwner(const char *name, Oid newOwnerId)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("server \"%s\" does not exist", name)));
 
-	form = (Form_pg_foreign_server) GETSTRUCT(tup);
+	form = GETSTRUCT(pg_foreign_server, tup);
 	servOid = form->oid;
 
 	AlterForeignServerOwner_internal(rel, tup, newOwnerId);
@@ -706,7 +706,7 @@ AlterForeignDataWrapper(ParseState *pstate, AlterFdwStmt *stmt)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("foreign-data wrapper \"%s\" does not exist", stmt->fdwname)));
 
-	fdwForm = (Form_pg_foreign_data_wrapper) GETSTRUCT(tp);
+	fdwForm = GETSTRUCT(pg_foreign_data_wrapper, tp);
 	fdwId = fdwForm->oid;
 
 	memset(repl_val, 0, sizeof(repl_val));
@@ -983,7 +983,7 @@ AlterForeignServer(AlterForeignServerStmt *stmt)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("server \"%s\" does not exist", stmt->servername)));
 
-	srvForm = (Form_pg_foreign_server) GETSTRUCT(tp);
+	srvForm = GETSTRUCT(pg_foreign_server, tp);
 	srvId = srvForm->oid;
 
 	/*
diff --git a/src/backend/commands/functioncmds.c b/src/backend/commands/functioncmds.c
index b016eecb2c..cdac19d505 100644
--- a/src/backend/commands/functioncmds.c
+++ b/src/backend/commands/functioncmds.c
@@ -101,7 +101,7 @@ compute_return_type(TypeName *returnType, Oid languageOid,
 
 	if (typtup)
 	{
-		if (!((Form_pg_type) GETSTRUCT(typtup))->typisdefined)
+		if (!(GETSTRUCT(pg_type, typtup))->typisdefined)
 		{
 			if (languageOid == SQLlanguageId)
 				ereport(ERROR,
@@ -241,7 +241,7 @@ interpret_function_parameter_list(ParseState *pstate,
 		typtup = LookupTypeName(NULL, t, NULL, false);
 		if (typtup)
 		{
-			if (!((Form_pg_type) GETSTRUCT(typtup))->typisdefined)
+			if (!(GETSTRUCT(pg_type, typtup))->typisdefined)
 			{
 				/* As above, hard error if language is SQL */
 				if (languageOid == SQLlanguageId)
@@ -1106,7 +1106,7 @@ CreateFunction(ParseState *pstate, CreateFunctionStmt *stmt)
 				 (extension_file_exists(language) ?
 				  errhint("Use CREATE EXTENSION to load the language into the database.") : 0)));
 
-	languageStruct = (Form_pg_language) GETSTRUCT(languageTuple);
+	languageStruct = GETSTRUCT(pg_language, languageTuple);
 	languageOid = languageStruct->oid;
 
 	if (languageStruct->lanpltrusted)
@@ -1313,7 +1313,7 @@ RemoveFunctionById(Oid funcOid)
 	if (!HeapTupleIsValid(tup)) /* should not happen */
 		elog(ERROR, "cache lookup failed for function %u", funcOid);
 
-	prokind = ((Form_pg_proc) GETSTRUCT(tup))->prokind;
+	prokind = (GETSTRUCT(pg_proc, tup))->prokind;
 
 	CatalogTupleDelete(relation, &tup->t_self);
 
@@ -1377,7 +1377,7 @@ AlterFunction(ParseState *pstate, AlterFunctionStmt *stmt)
 	if (!HeapTupleIsValid(tup)) /* should not happen */
 		elog(ERROR, "cache lookup failed for function %u", funcOid);
 
-	procForm = (Form_pg_proc) GETSTRUCT(tup);
+	procForm = GETSTRUCT(pg_proc, tup);
 
 	/* Permission check: must own function */
 	if (!pg_proc_ownercheck(funcOid, GetUserId()))
@@ -1600,7 +1600,7 @@ CreateCast(CreateCastStmt *stmt)
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for function %u", funcid);
 
-		procstruct = (Form_pg_proc) GETSTRUCT(tuple);
+		procstruct = GETSTRUCT(pg_proc, tuple);
 		nargs = procstruct->pronargs;
 		if (nargs < 1 || nargs > 3)
 			ereport(ERROR,
@@ -1868,7 +1868,7 @@ CreateTransform(CreateTransformStmt *stmt)
 		tuple = SearchSysCache1(PROCOID, ObjectIdGetDatum(fromsqlfuncid));
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for function %u", fromsqlfuncid);
-		procstruct = (Form_pg_proc) GETSTRUCT(tuple);
+		procstruct = GETSTRUCT(pg_proc, tuple);
 		if (procstruct->prorettype != INTERNALOID)
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
@@ -1894,7 +1894,7 @@ CreateTransform(CreateTransformStmt *stmt)
 		tuple = SearchSysCache1(PROCOID, ObjectIdGetDatum(tosqlfuncid));
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for function %u", tosqlfuncid);
-		procstruct = (Form_pg_proc) GETSTRUCT(tuple);
+		procstruct = GETSTRUCT(pg_proc, tuple);
 		if (procstruct->prorettype != typeid)
 			ereport(ERROR,
 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
@@ -1922,7 +1922,7 @@ CreateTransform(CreateTransformStmt *stmt)
 							ObjectIdGetDatum(langid));
 	if (HeapTupleIsValid(tuple))
 	{
-		Form_pg_transform form = (Form_pg_transform) GETSTRUCT(tuple);
+		Form_pg_transform form = GETSTRUCT(pg_transform, tuple);
 
 		if (!stmt->replace)
 			ereport(ERROR,
@@ -2106,7 +2106,7 @@ ExecuteDoStmt(ParseState *pstate, DoStmt *stmt, bool atomic)
 				 (extension_file_exists(language) ?
 				  errhint("Use CREATE EXTENSION to load the language into the database.") : 0)));
 
-	languageStruct = (Form_pg_language) GETSTRUCT(languageTuple);
+	languageStruct = GETSTRUCT(pg_language, languageTuple);
 	codeblock->langOid = languageStruct->oid;
 	codeblock->langIsTrusted = languageStruct->lanpltrusted;
 	codeblock->atomic = atomic;
@@ -2220,7 +2220,7 @@ ExecuteCallStmt(CallStmt *stmt, ParamListInfo params, bool atomic, DestReceiver
 	 * and AbortTransaction() resets the security context.  This could be
 	 * reorganized, but right now it doesn't work.
 	 */
-	if (((Form_pg_proc) GETSTRUCT(tp))->prosecdef)
+	if ((GETSTRUCT(pg_proc, tp))->prosecdef)
 		callcontext->atomic = true;
 
 	ReleaseSysCache(tp);
diff --git a/src/backend/commands/indexcmds.c b/src/backend/commands/indexcmds.c
index ff847579f3..233d265f71 100644
--- a/src/backend/commands/indexcmds.c
+++ b/src/backend/commands/indexcmds.c
@@ -212,7 +212,7 @@ CheckIndexCompatible(Oid oldId,
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("access method \"%s\" does not exist",
 						accessMethodName)));
-	accessMethodForm = (Form_pg_am) GETSTRUCT(tuple);
+	accessMethodForm = GETSTRUCT(pg_am, tuple);
 	accessMethodId = accessMethodForm->oid;
 	amRoutine = GetIndexAmRoutine(accessMethodForm->amhandler);
 	ReleaseSysCache(tuple);
@@ -245,7 +245,7 @@ CheckIndexCompatible(Oid oldId,
 	tuple = SearchSysCache1(INDEXRELID, ObjectIdGetDatum(oldId));
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "cache lookup failed for index %u", oldId);
-	indexForm = (Form_pg_index) GETSTRUCT(tuple);
+	indexForm = GETSTRUCT(pg_index, tuple);
 
 	/*
 	 * We don't assess expressions or predicates; assume incompatibility.
@@ -833,7 +833,7 @@ DefineIndex(Oid relationId,
 					 errmsg("access method \"%s\" does not exist",
 							accessMethodName)));
 	}
-	accessMethodForm = (Form_pg_am) GETSTRUCT(tuple);
+	accessMethodForm = GETSTRUCT(pg_am, tuple);
 	accessMethodId = accessMethodForm->oid;
 	amRoutine = GetIndexAmRoutine(accessMethodForm->amhandler);
 
@@ -1441,7 +1441,7 @@ DefineIndex(Oid relationId,
 					elog(ERROR, "cache lookup failed for index %u",
 						 indexRelationId);
 				newtup = heap_copytuple(tup);
-				((Form_pg_index) GETSTRUCT(newtup))->indisvalid = false;
+				(GETSTRUCT(pg_index, newtup))->indisvalid = false;
 				CatalogTupleUpdate(pg_index, &tup->t_self, newtup);
 				ReleaseSysCache(tup);
 				table_close(pg_index, RowExclusiveLock);
@@ -1822,7 +1822,7 @@ ComputeIndexAttrs(IndexInfo *indexInfo,
 							 errmsg("column \"%s\" does not exist",
 									attribute->name)));
 			}
-			attform = (Form_pg_attribute) GETSTRUCT(atttuple);
+			attform = GETSTRUCT(pg_attribute, atttuple);
 			indexInfo->ii_IndexAttrNumbers[attn] = attform->attnum;
 			atttype = attform->atttypid;
 			attcollation = attform->attcollation;
@@ -2044,7 +2044,7 @@ ComputeIndexAttrs(IndexInfo *indexInfo,
 				if (!HeapTupleIsValid(opftuple))
 					elog(ERROR, "cache lookup failed for opfamily %u",
 						 opfamily);
-				opfform = (Form_pg_opfamily) GETSTRUCT(opftuple);
+				opfform = GETSTRUCT(pg_opfamily, opftuple);
 
 				ereport(ERROR,
 						(errcode(ERRCODE_WRONG_OBJECT_TYPE),
@@ -2183,7 +2183,7 @@ ResolveOpClass(List *opclass, Oid attrType,
 	 * Verify that the index operator class accepts this datatype.  Note we
 	 * will accept binary compatibility.
 	 */
-	opform = (Form_pg_opclass) GETSTRUCT(tuple);
+	opform = GETSTRUCT(pg_opclass, tuple);
 	opClassId = opform->oid;
 	opInputType = opform->opcintype;
 
@@ -2246,7 +2246,7 @@ GetDefaultOpClass(Oid type_id, Oid am_id)
 
 	while (HeapTupleIsValid(tup = systable_getnext(scan)))
 	{
-		Form_pg_opclass opclass = (Form_pg_opclass) GETSTRUCT(tup);
+		Form_pg_opclass opclass = GETSTRUCT(pg_opclass, tup);
 
 		/* ignore altogether if not a default opclass */
 		if (!opclass->opcdefault)
@@ -2951,7 +2951,7 @@ ReindexMultipleTables(const char *objectName, ReindexObjectType objectKind,
 	scan = table_beginscan_catalog(relationRelation, num_keys, scan_keys);
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_class classtuple = (Form_pg_class) GETSTRUCT(tuple);
+		Form_pg_class classtuple = GETSTRUCT(pg_class, tuple);
 		Oid			relid = classtuple->oid;
 
 		/*
@@ -4194,7 +4194,7 @@ IndexSetParentIndex(Relation partitionIdx, Oid parentOid)
 	}
 	else
 	{
-		Form_pg_inherits inhForm = (Form_pg_inherits) GETSTRUCT(tuple);
+		Form_pg_inherits inhForm = GETSTRUCT(pg_inherits, tuple);
 
 		if (parentOid == InvalidOid)
 		{
@@ -4285,8 +4285,8 @@ update_relispartition(Oid relationId, bool newval)
 	tup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(relationId));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for relation %u", relationId);
-	Assert(((Form_pg_class) GETSTRUCT(tup))->relispartition != newval);
-	((Form_pg_class) GETSTRUCT(tup))->relispartition = newval;
+	Assert((GETSTRUCT(pg_class, tup))->relispartition != newval);
+	(GETSTRUCT(pg_class, tup))->relispartition = newval;
 	CatalogTupleUpdate(classRel, &tup->t_self, tup);
 	heap_freetuple(tup);
 	table_close(classRel, RowExclusiveLock);
diff --git a/src/backend/commands/matview.c b/src/backend/commands/matview.c
index 9ac0383459..0e5e86ccb3 100644
--- a/src/backend/commands/matview.c
+++ b/src/backend/commands/matview.c
@@ -100,7 +100,7 @@ SetMatViewPopulatedState(Relation relation, bool newstate)
 		elog(ERROR, "cache lookup failed for relation %u",
 			 RelationGetRelid(relation));
 
-	((Form_pg_class) GETSTRUCT(tuple))->relispopulated = newstate;
+	(GETSTRUCT(pg_class, tuple))->relispopulated = newstate;
 
 	CatalogTupleUpdate(pgrel, &tuple->t_self, tuple);
 
@@ -724,7 +724,7 @@ refresh_by_match_merge(Oid matviewOid, Oid tempOid, Oid relowner,
 				cla_ht = SearchSysCache1(CLAOID, ObjectIdGetDatum(opclass));
 				if (!HeapTupleIsValid(cla_ht))
 					elog(ERROR, "cache lookup failed for opclass %u", opclass);
-				cla_tup = (Form_pg_opclass) GETSTRUCT(cla_ht);
+				cla_tup = GETSTRUCT(pg_opclass, cla_ht);
 				Assert(cla_tup->opcmethod == BTREE_AM_OID);
 				opfamily = cla_tup->opcfamily;
 				opcintype = cla_tup->opcintype;
diff --git a/src/backend/commands/opclasscmds.c b/src/backend/commands/opclasscmds.c
index 7a931ab758..91b782ed0f 100644
--- a/src/backend/commands/opclasscmds.c
+++ b/src/backend/commands/opclasscmds.c
@@ -123,7 +123,7 @@ OpFamilyCacheLookup(Oid amID, List *opfamilyname, bool missing_ok)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("operator family \"%s\" does not exist for access method \"%s\"",
 						NameListToString(opfamilyname),
-						NameStr(((Form_pg_am) GETSTRUCT(amtup))->amname))));
+						NameStr((GETSTRUCT(pg_am, amtup))->amname))));
 	}
 
 	return htup;
@@ -145,7 +145,7 @@ get_opfamily_oid(Oid amID, List *opfamilyname, bool missing_ok)
 	htup = OpFamilyCacheLookup(amID, opfamilyname, missing_ok);
 	if (!HeapTupleIsValid(htup))
 		return InvalidOid;
-	opfamform = (Form_pg_opfamily) GETSTRUCT(htup);
+	opfamform = GETSTRUCT(pg_opfamily, htup);
 	opfID = opfamform->oid;
 	ReleaseSysCache(htup);
 
@@ -204,7 +204,7 @@ OpClassCacheLookup(Oid amID, List *opclassname, bool missing_ok)
 				(errcode(ERRCODE_UNDEFINED_OBJECT),
 				 errmsg("operator class \"%s\" does not exist for access method \"%s\"",
 						NameListToString(opclassname),
-						NameStr(((Form_pg_am) GETSTRUCT(amtup))->amname))));
+						NameStr((GETSTRUCT(pg_am, amtup))->amname))));
 	}
 
 	return htup;
@@ -226,7 +226,7 @@ get_opclass_oid(Oid amID, List *opclassname, bool missing_ok)
 	htup = OpClassCacheLookup(amID, opclassname, missing_ok);
 	if (!HeapTupleIsValid(htup))
 		return InvalidOid;
-	opcform = (Form_pg_opclass) GETSTRUCT(htup);
+	opcform = GETSTRUCT(pg_opclass, htup);
 	opcID = opcform->oid;
 	ReleaseSysCache(htup);
 
@@ -375,7 +375,7 @@ DefineOpClass(CreateOpClassStmt *stmt)
 				 errmsg("access method \"%s\" does not exist",
 						stmt->amname)));
 
-	amform = (Form_pg_am) GETSTRUCT(tup);
+	amform = GETSTRUCT(pg_am, tup);
 	amoid = amform->oid;
 	amroutine = GetIndexAmRoutineByAmId(amoid, false);
 	ReleaseSysCache(tup);
@@ -442,7 +442,7 @@ DefineOpClass(CreateOpClassStmt *stmt)
 							  ObjectIdGetDatum(namespaceoid));
 		if (HeapTupleIsValid(tup))
 		{
-			opfamilyoid = ((Form_pg_opfamily) GETSTRUCT(tup))->oid;
+			opfamilyoid = (GETSTRUCT(pg_opfamily, tup))->oid;
 
 			/*
 			 * XXX given the superuser check above, there's no need for an
@@ -630,7 +630,7 @@ DefineOpClass(CreateOpClassStmt *stmt)
 
 		while (HeapTupleIsValid(tup = systable_getnext(scan)))
 		{
-			Form_pg_opclass opclass = (Form_pg_opclass) GETSTRUCT(tup);
+			Form_pg_opclass opclass = GETSTRUCT(pg_opclass, tup);
 
 			if (opclass->opcintype == typeoid && opclass->opcdefault)
 				ereport(ERROR,
@@ -833,7 +833,7 @@ AlterOpFamily(AlterOpFamilyStmt *stmt)
 				 errmsg("access method \"%s\" does not exist",
 						stmt->amname)));
 
-	amform = (Form_pg_am) GETSTRUCT(tup);
+	amform = GETSTRUCT(pg_am, tup);
 	amoid = amform->oid;
 	amroutine = GetIndexAmRoutineByAmId(amoid, false);
 	ReleaseSysCache(tup);
@@ -1143,7 +1143,7 @@ assignOperTypes(OpFamilyMember *member, Oid amoid, Oid typeoid)
 	optup = SearchSysCache1(OPEROID, ObjectIdGetDatum(member->object));
 	if (!HeapTupleIsValid(optup))
 		elog(ERROR, "cache lookup failed for operator %u", member->object);
-	opform = (Form_pg_operator) GETSTRUCT(optup);
+	opform = GETSTRUCT(pg_operator, optup);
 
 	/*
 	 * Opfamily operators must be binary.
@@ -1210,7 +1210,7 @@ assignProcTypes(OpFamilyMember *member, Oid amoid, Oid typeoid,
 	proctup = SearchSysCache1(PROCOID, ObjectIdGetDatum(member->object));
 	if (!HeapTupleIsValid(proctup))
 		elog(ERROR, "cache lookup failed for function %u", member->object);
-	procform = (Form_pg_proc) GETSTRUCT(proctup);
+	procform = GETSTRUCT(pg_proc, proctup);
 
 	/* Check the signature of the opclass options parsing function */
 	if (member->number == opclassOptsProcNum)
diff --git a/src/backend/commands/operatorcmds.c b/src/backend/commands/operatorcmds.c
index a5924d7d56..312588f296 100644
--- a/src/backend/commands/operatorcmds.c
+++ b/src/backend/commands/operatorcmds.c
@@ -372,7 +372,7 @@ RemoveOperatorById(Oid operOid)
 	tup = SearchSysCache1(OPEROID, ObjectIdGetDatum(operOid));
 	if (!HeapTupleIsValid(tup)) /* should not happen */
 		elog(ERROR, "cache lookup failed for operator %u", operOid);
-	op = (Form_pg_operator) GETSTRUCT(tup);
+	op = GETSTRUCT(pg_operator, tup);
 
 	/*
 	 * Reset links from commutator and negator, if any.  In case of a
@@ -431,7 +431,7 @@ AlterOperator(AlterOperatorStmt *stmt)
 	tup = SearchSysCacheCopy1(OPEROID, ObjectIdGetDatum(oprId));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for operator %u", oprId);
-	oprForm = (Form_pg_operator) GETSTRUCT(tup);
+	oprForm = GETSTRUCT(pg_operator, tup);
 
 	/* Process options */
 	foreach(pl, stmt->options)
diff --git a/src/backend/commands/policy.c b/src/backend/commands/policy.c
index d9dff9ecaa..99e210fb7c 100644
--- a/src/backend/commands/policy.c
+++ b/src/backend/commands/policy.c
@@ -75,7 +75,7 @@ RangeVarCallbackForPolicy(const RangeVar *rv, Oid relid, Oid oldrelid,
 	if (!HeapTupleIsValid(tuple))
 		return;
 
-	classform = (Form_pg_class) GETSTRUCT(tuple);
+	classform = GETSTRUCT(pg_class, tuple);
 	relkind = classform->relkind;
 
 	/* Must own relation. */
@@ -236,7 +236,7 @@ RelationBuildRowSecurity(Relation relation)
 
 	while (HeapTupleIsValid(tuple = systable_getnext(sscan)))
 	{
-		Form_pg_policy policy_form = (Form_pg_policy) GETSTRUCT(tuple);
+		Form_pg_policy policy_form = GETSTRUCT(pg_policy, tuple);
 		RowSecurityPolicy *policy;
 		Datum		datum;
 		bool		isnull;
@@ -366,7 +366,7 @@ RemovePolicyById(Oid policy_id)
 	 * set of policies the rel has; furthermore we've got to hold the lock
 	 * till commit.)
 	 */
-	relid = ((Form_pg_policy) GETSTRUCT(tuple))->polrelid;
+	relid = (GETSTRUCT(pg_policy, tuple))->polrelid;
 
 	rel = table_open(relid, AccessExclusiveLock);
 	if (rel->rd_rel->relkind != RELKIND_RELATION &&
@@ -455,7 +455,7 @@ RemoveRoleFromObjectPolicy(Oid roleid, Oid classid, Oid policy_id)
 		elog(ERROR, "could not find tuple for policy %u", policy_id);
 
 	/* Identify rel the policy belongs to */
-	relid = ((Form_pg_policy) GETSTRUCT(tuple))->polrelid;
+	relid = (GETSTRUCT(pg_policy, tuple))->polrelid;
 
 	/* Get the current set of roles */
 	roles_datum = heap_getattr(tuple,
@@ -917,7 +917,7 @@ AlterPolicy(AlterPolicyStmt *stmt)
 				(errcode(ERRCODE_SYNTAX_ERROR),
 				 errmsg("only WITH CHECK expression allowed for INSERT")));
 
-	policy_id = ((Form_pg_policy) GETSTRUCT(policy_tuple))->oid;
+	policy_id = (GETSTRUCT(pg_policy, policy_tuple))->oid;
 
 	if (role_ids != NULL)
 	{
@@ -1169,11 +1169,11 @@ rename_policy(RenameStmt *stmt)
 				 errmsg("policy \"%s\" for table \"%s\" does not exist",
 						stmt->subname, RelationGetRelationName(target_table))));
 
-	opoloid = ((Form_pg_policy) GETSTRUCT(policy_tuple))->oid;
+	opoloid = (GETSTRUCT(pg_policy, policy_tuple))->oid;
 
 	policy_tuple = heap_copytuple(policy_tuple);
 
-	namestrcpy(&((Form_pg_policy) GETSTRUCT(policy_tuple))->polname,
+	namestrcpy(&(GETSTRUCT(pg_policy, policy_tuple))->polname,
 			   stmt->newname);
 
 	CatalogTupleUpdate(pg_policy_rel, &policy_tuple->t_self, policy_tuple);
@@ -1243,7 +1243,7 @@ get_relation_policy_oid(Oid relid, const char *policy_name, bool missing_ok)
 		policy_oid = InvalidOid;
 	}
 	else
-		policy_oid = ((Form_pg_policy) GETSTRUCT(policy_tuple))->oid;
+		policy_oid = (GETSTRUCT(pg_policy, policy_tuple))->oid;
 
 	/* Clean up. */
 	systable_endscan(sscan);
diff --git a/src/backend/commands/proclang.c b/src/backend/commands/proclang.c
index 4a093f45d8..d28274e3c4 100644
--- a/src/backend/commands/proclang.c
+++ b/src/backend/commands/proclang.c
@@ -124,7 +124,7 @@ CreateProceduralLanguage(CreatePLangStmt *stmt)
 
 	if (HeapTupleIsValid(oldtup))
 	{
-		Form_pg_language oldform = (Form_pg_language) GETSTRUCT(oldtup);
+		Form_pg_language oldform = GETSTRUCT(pg_language, oldtup);
 
 		/* There is one; okay to replace it? */
 		if (!stmt->replace)
